.\" SPDX-License-Identifier: BSD-2-Clause

.\" Copyright (c) 2021 Alessio Chiapperini

.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.

.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.

.Dd November 16, 2021
.Dt C8EMUL 1
.Os
.Sh NAME
.Nm c8emul
.Nd CHIP-8 emulator
.Sh SYNOPSIS
.Nm
.Op Fl s Ar scaling_factor
.Op Fl d Ar cycle_delay
.Op Ar rom_file
.Sh DESCRIPTION
.Nm
is a CHIP-8 emulator implemented in C99 using the SDL2 multimedia library.
If the
.Ar rom_file
is absent,
.Nm
reads from standard input. The predefined window size is 64x32, but it can be scaled up using the
.Ar scaling_factor
flag. Moreover, since the CHIP-8 has no specified clock speed and different games run at different
speeds, the delay in milliseconds between cycles can be specified via the
.Ar cycle_delay
flag which defaults to 3ms if not specified otherwise.
.Pp
The options are as follows:
.Bl -tag -width indent
.It Fl s Ar scaling_factor
Use
.Ar scaling_factor
as a multiplier for the predefined window size of 64x32.
.It Fl d Ar cycle_delay
Use
.Ar cycle_delay
as time in milliseconds between cycles.
.El
.Sh "EXIT STATUS"
The
.Nm
utility exits 0 on success, and 1 if an error occurs.
.Sh EXAMPLES
Load ROM from stdin and display it in 640x320 with the default 3ms cycle delay:
.Dl "c8emul -s 10"
.Pp
Load ROM from file and scale the window to 640x320 with a 2ms cycle delay:
.Pp
.Dl "c8emul -s 10 -d 2 Chip8_Picture.ch8"
.Sh BUGS
.Bl -tag -width indent
.It Audio is not supported.
.El
.Sh AUTHOR
.An Alessio Chiapperini Aq Mt alessio.chiapperini@\:nullbuffer.com 
